package com.xin.shardingspherejdbcdemo.config.sharding;

import com.xin.shardingspherejdbcdemo.service.impl.JdbcServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

/**
 * 基于范围分表的 ActualDataNodes 动态刷新JOB
 *
 * @author qimok
 * @since 2020-09-07
 */
@Slf4j
@Component
public class ShardingTableRuleActualDataNodesRefreshJob {


    /**
     * 6 个小时执行一次
     */
    @Autowired
    private JdbcServiceImpl jdbcService;
    @Scheduled(cron = "0 0 23 * * ?")
    public void refreshActualDataNodes(){
        log.info("开始执行自动扩容策略");
        jdbcService.checkDb();
        log.info("结束执行自动扩容策略");
    }


}
