package com.xin.shardingspherejdbcdemo.entity.vo;

public class AjaxVo<T> {
    static interface Code {
        static int SUCCESS = 0;
        static int ERROR = 1;
    }

    static interface MSG {
        static String SUCCESS = "成功!";
        static String ERROR = "系统错误!";
    }


    private int code;
    private String msg;
    private T data;

    public static <T> AjaxVo success() {
        AjaxVo ajaxVo = new AjaxVo();
        ajaxVo.setMsg(MSG.SUCCESS);
        ajaxVo.setCode(Code.SUCCESS);
        return ajaxVo;
    }

    public static <T> AjaxVo success(T t) {
        AjaxVo ajaxVo = new AjaxVo();
        ajaxVo.setData(t);
        ajaxVo.setMsg(MSG.SUCCESS);
        ajaxVo.setCode(Code.SUCCESS);
        return ajaxVo;
    }

    public static AjaxVo error(String msg) {
        AjaxVo ajaxVo = new AjaxVo();
        ajaxVo.setMsg(msg);
        ajaxVo.setCode(Code.ERROR);
        return ajaxVo;
    }

    public static AjaxVo error() {
        AjaxVo ajaxVo = new AjaxVo();
        ajaxVo.setMsg(MSG.ERROR);
        ajaxVo.setCode(Code.ERROR);
        return ajaxVo;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public T getData() {
        return data;
    }

    public void setData(T data) {
        this.data = data;
    }
}
