package com.xin.shardingspherejdbcdemo.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.xin.shardingspherejdbcdemo.config.util.SnowFlake;
import com.xin.shardingspherejdbcdemo.entity.Order;
import com.xin.shardingspherejdbcdemo.entity.Order;
import com.xin.shardingspherejdbcdemo.entity.vo.PageVo;
import com.xin.shardingspherejdbcdemo.mapper.OrderMapper;
import com.xin.shardingspherejdbcdemo.service.OrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class OrderServiceImpl implements OrderService {
    @Autowired
    private OrderMapper orderMapper;

    @Override
    public PageVo list(int pageNum, int pageSize, String orderNum) {
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.like("order_num", orderNum);
        int count = orderMapper.selectCount(queryWrapper);
        queryWrapper.orderBy(true, true, "money");
        PageHelper.startPage(pageNum, pageSize);
        List<Order> list = orderMapper.selectList(queryWrapper);
        return PageVo.data(list, count);
    }


    @Override
    public Order save(Order order) {
        SnowFlake snowFlake = new SnowFlake(2, 3);
        order.setId(snowFlake.nextId());
        orderMapper.insert(order);
        return order;
    }


    @Override
    public Order info(Long id) {
        return orderMapper.selectById(id);
    }

    @Override
    @Transactional
    public Order update(Order order) {
        orderMapper.updateById(order);
        return order;
    }

    @Override
    @Transactional
    public Long delete(Long id) {
        orderMapper.deleteById(id);
        return id;
    }
}
