package com.xin.shardingspherejdbcdemo.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.xin.shardingspherejdbcdemo.config.util.SnowFlake;
import com.xin.shardingspherejdbcdemo.entity.Order;
import com.xin.shardingspherejdbcdemo.entity.User;
import com.xin.shardingspherejdbcdemo.entity.vo.PageVo;
import com.xin.shardingspherejdbcdemo.mapper.OrderMapper;
import com.xin.shardingspherejdbcdemo.mapper.UserMapper;
import com.xin.shardingspherejdbcdemo.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;


@Service
public class UserServiceImpl implements UserService {

    @Autowired
    private UserMapper userMapper;

    @Override
    public PageVo list(int pageNum, int pageSize, String name, Integer age) {
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.like("name", name);
        queryWrapper.le("age", age);
        int count = userMapper.selectCount(queryWrapper);
        queryWrapper.orderByAsc("age");
        PageHelper.startPage(pageNum, pageSize);
        List<User> list = userMapper.selectList(queryWrapper);
        return PageVo.data(list, count);
    }


    @Override
    public User save(User user) {
        SnowFlake snowFlake = new SnowFlake(2, 3);
        user.setId(snowFlake.nextId());
        userMapper.insert(user);
        return user;
    }


    @Override
    public User info(Long id) {
        return userMapper.selectById(id);
    }

    @Override
    @Transactional
    public User update(User user) {
        userMapper.updateById(user);
        return user;
    }

    @Override
    @Transactional
    public Long delete(Long id) {
        userMapper.deleteById(id);
        return id;
    }

    @Autowired
    private OrderMapper orderMapper;

    @Override
    public Object order(Order order) {
        SnowFlake snowFlake = new SnowFlake(2, 3);
        order.setId(snowFlake.nextId());
        orderMapper.insert(order);
        return order;
    }


    @Override
    public Object selectOrder(Long userId, int pageNum, int pageSize, String name) {
        PageHelper.startPage(pageNum, pageSize);
        List<Map<String, String>> list = userMapper.selectOrderByid(userId);
        long total = new PageInfo(list).getTotal();
        return PageVo.data(list, total);
    }


}
